#!/bin/bash

interfaces=$(ip a|awk '/inet / &&!/ lo/ {print $NF}'|uniq)
ETHER_IF=""
WLAN_IF=""
DHCP_CLIENT=""
INTERFACE_FILE=/etc/network/interfaces
WPA_CONF="`pwd`/wpa_supplicant.conf"
WPA_CONF_EXAMPLE="`pwd`/wpa_supplicant.conf.example"

function init_interfaces()
{
    for i in $interfaces; do
        if [[ $i == e* ]]; then
            ETHER_IF=$i
        elif [[ $i == w* ]]; then
            WLAN_IF=$i
        else
            echo "unknown $i"
        fi
    done
    # sometimes we get eth0:avaahi
    echo "ether: ${ETHER_IF}"
    echo "wlan: ${WLAN_IF}"
}

function init_dhcp_client()
{
    r=`which dhclient`
    if [ $? == 0 ] && [ -z $DHCP_CLIENT ]; then
        DHCP_CLIENT=`which dhclient`
    fi

    r=`which dhcpd`
    if [ $? == 0 ] && [ -z $DHCP_CLIENT ]; then
        DHCP_CLIENT=`which dhcpd`
    fi

    if [ -z $DHCP_CLIENT ]; then
        return -1
    else
        echo $DHCP_CLIENT
        return 0
    fi
}

function quit_if_not_root
{
    if (( $EUID != 0 )); then
        echo "Please run as root"
        exit
    fi
}

function create_wpa_conf()
{
    ca_path=$3
    private_key_path=$2
    #private_id="xiaotian.lxt"
    private_id=$1
    sed_cmd="s#user-id#$private_id#g;s#ca-path#$ca_path#g;s#p12-path#$private_key_path#g"
    sed -e $sed_cmd $WPA_CONF_EXAMPLE > wpa_supplicant.conf
    echo "save to ./wpa_supplicant.conf"
}


init_interfaces
init_dhcp_client
create_wpa_conf	$1 $2 $3
